#!/usr/bin/perl

use strict;

open(STDOUT, ">xl_errno.c");

if (scalar(@ARGV) == 0) {
	@ARGV = qw(
		/usr/include/asm-generic/errno-base.h
		/usr/include/asm-generic/errno.h
	);
}

@_ = <>;

print <<"--EOT";
/* Generated by gen_xl_errno.pl */
#include <errno.h>

static const int arch_to_generic_table[] = {
	[0] = 0,
--EOT

foreach (@_) {
	if (/^\s*#define\s+(\S+)\s+(\d+)/) {
		print "\t[$1] = -$2,\n";
	}
}

print <<"--EOT";
};

static const int generic_to_arch_table[] = {
	[0] = 0,
--EOT

foreach (@_) {
	if (/^\s*#define\s+(\S+)\s+(\d+)/) {
		print "\t[$2] = -$1,\n";
	}
}

print <<"--EOT";
};
--EOT
